SymFindC:
 lea -12(a7),a7
 move.l a7,a1
 clr.w (a1)+
 move.l (a0)+,(a1)+
 move.l (a0),(a1)+
 clr.w (a1)
 subq.l #8,a1
sfc_0:
 tst.b (a1)+
 bne sfc_0
 subq.l #1,a1
 move.l a1,-(a7)
 RC SymFind
 lea 16(a7),a7
 rts
OldInt1:
 dc.l 0
 even
OldInt5:
 dc.l 0
 even
randnum:
 dc.l 0
seedrand:
 move.l $C8,randnum
 rts
ChgRand: ;changes randnum using the BCPL linear congruential generator method (will set randnum to randnum*0x7FF8A3ED+715136305).  Saves all registers
 move.l d0,-(a7)
 move.l d1,-(a7)
 move.l d2,-(a7)
 move.l randnum(pc),d0
 move.w d0,d1
 mulu.w #$A3ED,d1
 move.w d0,d2
 mulu.w #$7FF8,d2
 swap d1
 add.w d2,d1
 mulu.w #$A3ED,d0
 add.w d0,d1
 swap d1
 add.l #715136305,d1
 move.l d1,randnum
 move.l (a7)+,d2
 move.l (a7)+,d1
 move.l (a7)+,d0
 rts
DUMMY_HANDLER: ;also does random change
 bsr ChgRand
 rte
RAND_HANDLER:
 bsr ChgRand
 move.l a0,-(a7)
 move.l OldInt1,a0
 pea RH_1(pc)
 move SR,-(a7)
 jmp (a0)
RH_1:
 move.l (a7)+,a0
 rte
SaveAI1:
 bclr.b #2,$600001
 move.l ($64).w,OldInt1
 move.l ($74).w,OldInt5
 move.l #RAND_HANDLER,($64).w
 bset.b #2,$600001
 rts
ClearAI1:
 bclr.b #2,$600001
 lea DUMMY_HANDLER,a0
 move.l a0,($64).w
 move.l a0,($74).w
 bset.b #2,$600001
 rts
RestoreAI1:
 bclr.b #2,$600001
 move.l OldInt1,($64).w
 move.l OldInt5,($74).w
 bset.b #2,$600001
 rts
rowread:
 move.w d0,$600018
 moveq #24,d0
kc_1:
 dbf d0,kc_1
 moveq #0,d0
 move.b $60001B,d0
 not.b d0
 rts
;keytest(row(d0),column(d1));
keytest:
 moveq #1,d2
 lsl.w d0,d2
 not.w d2
 move.w d2,d0
 bsr rowread
 moveq #1,d2
 lsl.w d1,d2
 and.w d2,d0
 rts
;game key bits from 0 to 8 (9 total bits):up(0),left(1),down(2),right(3),2nd(4),shift(5),diamond(6),alpha(7),esc(8)
testgamekeys:
 moveq #-2,d0 ;meaning row zero, since this is ~1.
 bsr rowread
 move.b d0,-(a7)
 moveq #-65,d0 ;meaning row 6
 bsr rowread
 move.w d0,d1
 moveq #0,d0
 move.b (a7)+,d0
 btst #0,d1
 beq tuldre_rts
 or.w #256,d0
tuldre_rts:
 rts
;Sprite8(x0(d0),y0(d1),height(d2),sprt(a0),vm_addr(a1))
Sprite8:
 move.l d3,-(a7)
 muls.w #30,d1
 adda.l d1,a1 ;advance to first row
 move.w d0,d1
 asr.w #3,d1
 adda.w d1,a1 ;advance to first byte
 and.w #7,d0 ;shift count 0
 moveq #8,d3
 sub.w d0,d3 ;shift count 1
Sprite8_loop:
 subq.w #1,d2
 blt Sprite8_end
 move.b (a0),d1
 lsr.b d0,d1
 eor.b d1,(a1)+
 move.b (a0)+,d1
 lsl.b d3,d1
 eor.b d1,(a1)
 lea 29(a1),a1
 bra Sprite8_loop
Sprite8_end:
 move.l (a7)+,d3
 rts
;a0 is a word number of lines followed by a list of word parameters
DrawLineMap:
 move.l a5,-(a7)
 move.l a2,-(a7)
 move.l d3,-(a7)
 move.l ($C8).w,a5
 move.l $1A7*4(a5),a5 ;DrawLine
 move.w (a0)+,d3
 move.w d3,d0
 mulu.w #10,d0
 lea 0(a0,d0.l),a2
DLM_Loop:
 subq.w #1,d3
 blt DLM_End
 move.w -(a2),-(a7)
 move.l -(a2),-(a7)
 move.l -(a2),-(a7)
 jsr (a5)
 lea 10(a7),a7
 bra DLM_Loop
DLM_End:
 move.l (a7)+,d3
 move.l (a7)+,a2
 move.l (a7)+,a5
 rts
;x(d0),y(d1),text(a0)
DrawStr_Reg:
 move.w #4,-(a7) ;A_REPLACE
 move.l a0,-(a7)
 move.w d1,-(a7)
 move.w d0,-(a7)
 RC DrawStr
 lea 10(a7),a7
 rts
;at a0: number of strings.w,start coordinate.w,height of each line.w,strings terminated by 0
DrawStrList:
 movem.l d3-d5/a2-a3,-(a7)
 move.l ($C8).w,a3
 move.l $1A9*4(a3),a3 ;DrawStr
 move.l a0,a2
 move.w (a2)+,d3
 move.w (a2)+,d4
 swap d4
 move.w (a2)+,d4
 move.w (a2)+,d5
DSL_Loop:
 subq.w #1,d3
 blt DSL_End
 move.w #4,-(a7) ;A_REPLACE
 move.l a2,-(a7)
 move.l d4,-(a7)
 jsr (a3)
 lea 10(a7),a7
 add.w d5,d4
 ;scan for next string
DSL_LoopStr
 tst.b (a2)+
 bne DSL_LoopStr
 bra DSL_Loop
DSL_End:
 movem.l (a7)+,d3-d5/a2-a3
 rts
 